Index: /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17398)
+++ /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17399)
@@ -174,4 +174,10 @@
     <Compile Include="Regression\Physics\PhysicsInstanceProvider.cs" />
     <Compile Include="Regression\Physics\RocketFuelFlow.cs" />
+    <Compile Include="Regression\ScalingProblems\ScalingProblem1.cs" />
+    <Compile Include="Regression\ScalingProblems\ScalingProblem2.cs" />
+    <Compile Include="Regression\ScalingProblems\ScalingProblem3.cs" />
+    <Compile Include="Regression\ScalingProblems\ScalingProblem4.cs" />
+    <Compile Include="Regression\ScalingProblems\ScalingProblem5.cs" />
+    <Compile Include="Regression\ScalingProblems\ScalingProblemInstanceProvider.cs" />
     <Compile Include="Regression\VariableNetworks\LinearVariableNetwork.cs" />
     <Compile Include="Regression\VariableNetworks\GaussianProcessVariableNetwork.cs" />
Index: /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem1.cs
===================================================================
--- /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem1.cs	(revision 17399)
+++ /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem1.cs	(revision 17399)
@@ -0,0 +1,80 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis
+{
+	public class ScalingProblem1 : ArtificialRegressionDataDescriptor
+	{
+
+		public override string Name { get { return "JKK-1 F1(X1,X2) = log(X1 + X2)"; } }
+		public override string Description
+		{
+			get
+			{
+				return "Function: F1(X1,X2) = log(X1 + Y1)" + Environment.NewLine
+				+ "Data: 100 points X1, X2 = Rand(1, 2)" + Environment.NewLine
+				+ "Function Set: +, -, *, /, square, e^x, e^-x, x^eps, x + eps, x * eps";
+			}
+		}
+		protected override string TargetVariable { get { return "Y"; } }
+		protected override string[] VariableNames { get { return new string[] { "X1", "X2", "Y" }; } }
+		protected override string[] AllowedInputVariables { get { return new string[] { "X1", "X2" }; } }
+		protected override int TrainingPartitionStart { get { return 0; } }
+		protected override int TrainingPartitionEnd { get { return 100; } }
+		protected override int TestPartitionStart { get { return 100; } }
+		protected override int TestPartitionEnd { get { return 500; } }
+
+		public int Seed { get; private set; }
+
+		public ScalingProblem1() : this((int)DateTime.Now.Ticks) { }
+
+		public ScalingProblem1(int seed) : base()
+		{
+			Seed = seed;
+		}
+		protected override List<List<double>> GenerateValues()
+		{
+			var rand = new MersenneTwister((uint)Seed);
+			var data = Enumerable.Range(0, AllowedInputVariables.Count()).Select(_ => Enumerable.Range(0, TestPartitionEnd).Select(__ => rand.NextDouble() + 1).ToList()).ToList();
+
+			double x1, x2;
+			List<double> results = new List<double>();
+
+			double res;
+
+			for (int i = 0; i < data[0].Count; i++)
+			{
+				x1 = data[0][i];
+				x2 = data[1][i];
+				results.Add(Math.Log(x1 + x2));
+			}
+			data.Add(results);
+
+			return data;
+		}
+	}
+}
Index: /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem2.cs
===================================================================
--- /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem2.cs	(revision 17399)
+++ /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem2.cs	(revision 17399)
@@ -0,0 +1,79 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis
+{
+	public class ScalingProblem2 : ArtificialRegressionDataDescriptor
+	{
+
+		public override string Name { get { return "JKK-2 F2(X1,X2,X3) = sqrt((X1 + X2)/X3)"; } }
+		public override string Description
+		{
+			get
+			{
+				return "Function: F2(X1,X2,X3) = sqrt((X1 + X2)/X3)" + Environment.NewLine
+				+ "Data: 100 points X1, X2, X3 = Rand(1, 2)" + Environment.NewLine
+				+ "Function Set: +, -, *, /, square, e^x, e^-x, x^eps, x + eps, x * eps";
+			}
+		}
+		protected override string TargetVariable { get { return "Y"; } }
+		protected override string[] VariableNames { get { return new string[] { "X1", "X2", "X3", "Y" }; } }
+		protected override string[] AllowedInputVariables { get { return new string[] { "X1", "X2", "X3" }; } }
+		protected override int TrainingPartitionStart { get { return 0; } }
+		protected override int TrainingPartitionEnd { get { return 100; } }
+		protected override int TestPartitionStart { get { return 100; } }
+		protected override int TestPartitionEnd { get { return 500; } }
+
+		public int Seed { get; private set; }
+
+		public ScalingProblem2() : this((int)DateTime.Now.Ticks) { }
+
+		public ScalingProblem2(int seed) : base()
+		{
+			Seed = seed;
+		}
+		protected override List<List<double>> GenerateValues()
+		{
+			var rand = new MersenneTwister((uint)Seed);
+			var data = Enumerable.Range(0, AllowedInputVariables.Count()).Select(_ => Enumerable.Range(0, TestPartitionEnd).Select(__ => rand.NextDouble() + 1).ToList()).ToList();
+
+			double x1, x2, x3;
+
+			List<double> results = new List<double>();
+			for (int i = 0; i < data[0].Count; i++)
+			{
+				x1 = data[0][i];
+				x2 = data[1][i];
+				x3 = data[2][i];
+				results.Add(Math.Sqrt((x1 + x2) / x3));
+			}
+			data.Add(results);
+
+			return data;
+		}
+	}
+}
Index: /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem3.cs
===================================================================
--- /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem3.cs	(revision 17399)
+++ /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem3.cs	(revision 17399)
@@ -0,0 +1,86 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis
+{
+	public class ScalingProblem3 : ArtificialRegressionDataDescriptor
+	{
+
+		public override string Name { get { return "JKK-3 F3(X1,X2,X3,X4,X5,X6,X7,X8,X9,X10) = X1*X2 + X3*X4 + X5*X6 + X1*X7*X9 + X3*X6*X10)"; } }
+		public override string Description
+		{
+			get
+			{
+				return "Function: F3(X1,X2,X3,X4,X5,X6,X7,X8,X9,X10) = X1*X2 + X3*X4 + X5*X6 + X1*X7*X9 + X3*X6*X10)" + Environment.NewLine
+				+ "Data: 250 points X1, X2, X3, X4, X5, X6, X7, X8, X9, X10 = Rand(10, 20)" + Environment.NewLine
+				+ "Function Set: +, -, *, /, square, e^x, e^-x, x^eps, x + eps, x * eps";
+			}
+		}
+		protected override string TargetVariable { get { return "Y"; } }
+		protected override string[] VariableNames { get { return new string[] { "X1", "X2", "X3", "X4", "X5", "X6", "X7", "X8", "X9", "X10", "Y" }; } }
+		protected override string[] AllowedInputVariables { get { return new string[] { "X1", "X2", "X3", "X4", "X5", "X6", "X7", "X8", "X9", "X10" }; } }
+		protected override int TrainingPartitionStart { get { return 0; } }
+		protected override int TrainingPartitionEnd { get { return 250; } }
+		protected override int TestPartitionStart { get { return 250; } }
+		protected override int TestPartitionEnd { get { return 1000; } }
+
+		public int Seed { get; private set; }
+
+		public ScalingProblem3() : this((int)DateTime.Now.Ticks) { }
+
+		public ScalingProblem3(int seed) : base()
+		{
+			Seed = seed;
+		}
+		protected override List<List<double>> GenerateValues()
+		{
+			var rand = new MersenneTwister((uint)Seed);
+			var data = Enumerable.Range(0, AllowedInputVariables.Count()).Select(_ => Enumerable.Range(0, TestPartitionEnd).Select(__ => rand.NextDouble() * 10 + 10).ToList()).ToList();
+
+			double x1, x2, x3, x4, x5, x6, x7, x8, x9, x10;
+
+			List<double> results = new List<double>();
+			for (int i = 0; i < data[0].Count; i++)
+			{
+				x1 = data[0][i];
+				x2 = data[1][i];
+				x3 = data[2][i];
+				x4 = data[3][i];
+				x5 = data[4][i];
+				x6 = data[5][i];
+				x7 = data[6][i];
+				x8 = data[7][i];
+				x9 = data[8][i];
+				x10 = data[9][i];
+				results.Add(x1 * x2 + x3 * x4 + x5 * x6 + x1 * x7 * x9 + x3 * x6 * x10);
+			}
+			data.Add(results);
+
+			return data;
+		}
+	}
+}
Index: /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem4.cs
===================================================================
--- /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem4.cs	(revision 17399)
+++ /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem4.cs	(revision 17399)
@@ -0,0 +1,86 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis
+{
+	public class ScalingProblem4 : ArtificialRegressionDataDescriptor
+	{
+
+		public override string Name { get { return "JKK-4 F4(X1,X2,X3,X4,X5,X6,X7,X8,X9,X10) = X1/X2 + X3/X4 + X5/X6 + X1*X7/X9 + X3*X6/X10)"; } }
+		public override string Description
+		{
+			get
+			{
+				return "Function: F4(X1,X2,X3,X4,X5,X6,X7,X8,X9,X10) = X1*X2 + X3*X4 + X5*X6 + X1*X7*X9 + X3*X6*X10)" + Environment.NewLine
+				+ "Data: 250 points X1, X2, X3, X4, X5, X6, X7, X8, X9, X10 = Rand(10, 20)" + Environment.NewLine
+				+ "Function Set: +, -, *, /, square, e^x, e^-x, x^eps, x + eps, x * eps";
+			}
+		}
+		protected override string TargetVariable { get { return "Y"; } }
+		protected override string[] VariableNames { get { return new string[] { "X1", "X2", "X3", "X4", "X5", "X6", "X7", "X8", "X9", "X10", "Y" }; } }
+		protected override string[] AllowedInputVariables { get { return new string[] { "X1", "X2", "X3", "X4", "X5", "X6", "X7", "X8", "X9", "X10" }; } }
+		protected override int TrainingPartitionStart { get { return 0; } }
+		protected override int TrainingPartitionEnd { get { return 250; } }
+		protected override int TestPartitionStart { get { return 250; } }
+		protected override int TestPartitionEnd { get { return 1000; } }
+
+		public int Seed { get; private set; }
+
+		public ScalingProblem4() : this((int)DateTime.Now.Ticks) { }
+
+		public ScalingProblem4(int seed) : base()
+		{
+			Seed = seed;
+		}
+		protected override List<List<double>> GenerateValues()
+		{
+			var rand = new MersenneTwister((uint)Seed);
+			var data = Enumerable.Range(0, AllowedInputVariables.Count()).Select(_ => Enumerable.Range(0, TestPartitionEnd).Select(__ => rand.NextDouble() * 10 + 10).ToList()).ToList();
+
+			double x1, x2, x3, x4, x5, x6, x7, x8, x9, x10;
+
+			List<double> results = new List<double>();
+			for (int i = 0; i < data[0].Count; i++)
+			{
+				x1 = data[0][i];
+				x2 = data[1][i];
+				x3 = data[2][i];
+				x4 = data[3][i];
+				x5 = data[4][i];
+				x6 = data[5][i];
+				x7 = data[6][i];
+				x8 = data[7][i];
+				x9 = data[8][i];
+				x10 = data[9][i];
+				results.Add(x1 / x2 + x3 / x4 + x5 / x6 + x1 * x7 / x9 + x3 * x6 / x10);
+			}
+			data.Add(results);
+
+			return data;
+		}
+	}
+}
Index: /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem5.cs
===================================================================
--- /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem5.cs	(revision 17399)
+++ /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblem5.cs	(revision 17399)
@@ -0,0 +1,80 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis
+{
+	public class ScalingProblem5 : ArtificialRegressionDataDescriptor
+	{
+
+		public override string Name { get { return "JKK-5 F5(X1,X2,X3) = sqrt(X1/log(X2)) + X1/X3"; } }
+		public override string Description
+		{
+			get
+			{
+				return "Function: F5(X1,X2,X3) = sqrt(X1/log(X2)) + X1/X3" + Environment.NewLine
+				+ "Data: 250 points X1, X3 = Rand(1, 2), X2 = Rand(2,100)" + Environment.NewLine
+				+ "Function Set: +, -, *, /, square, e^x, e^-x, x^eps, x + eps, x * eps";
+			}
+		}
+		protected override string TargetVariable { get { return "Y"; } }
+		protected override string[] VariableNames { get { return new string[] { "X1", "X2", "X3", "Y" }; } }
+		protected override string[] AllowedInputVariables { get { return new string[] { "X1", "X2", "X3" }; } }
+		protected override int TrainingPartitionStart { get { return 0; } }
+		protected override int TrainingPartitionEnd { get { return 250; } }
+		protected override int TestPartitionStart { get { return 250; } }
+		protected override int TestPartitionEnd { get { return 1000; } }
+
+		public int Seed { get; private set; }
+
+		public ScalingProblem5() : this((int)DateTime.Now.Ticks) { }
+
+		public ScalingProblem5(int seed) : base()
+		{
+			Seed = seed;
+		}
+		protected override List<List<double>> GenerateValues()
+		{
+			var rand = new MersenneTwister((uint)Seed);
+
+			var data = Enumerable.Range(0, AllowedInputVariables.Count()).Select(_ => Enumerable.Range(0, TestPartitionEnd).Select(__ => rand.NextDouble() + 1).ToList()).ToList();
+			data[1] = Enumerable.Range(0, TestPartitionEnd).Select(_ => rand.NextDouble() * 99 + 1).ToList();
+
+			double x1, x2, x3;
+			List<double> results = new List<double>();
+			for (int i = 0; i < data[0].Count; i++)
+			{
+				x1 = data[0][i]; 
+				x2 = data[1][i];
+				x3 = data[2][i];
+				results.Add(Math.Sqrt(x1 / (Math.Log(x2))) + (x1 / x3));
+			}
+			data.Add(results);
+
+			return data;
+		}
+	}
+}
Index: /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblemInstanceProvider.cs
===================================================================
--- /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblemInstanceProvider.cs	(revision 17399)
+++ /branches/3043-Regression-Instances-For-Scaling/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ScalingProblems/ScalingProblemInstanceProvider.cs	(revision 17399)
@@ -0,0 +1,67 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis
+{
+	public class ScalingProblemInstanceProvider : ArtificialRegressionInstanceProvider
+	{
+		public override string Name
+		{
+			get { return "Scaling Benchmark Problems"; }
+		}
+		public override string Description
+		{
+			get { return ""; }
+		}
+		public override Uri WebLink
+		{
+			get { return new Uri("http://www.x.com"); }
+		}
+		public override string ReferencePublication
+		{
+			get { return ""; }
+		}
+
+		public int Seed { get; private set; }
+
+		public ScalingProblemInstanceProvider() : this((int)DateTime.Now.Ticks) { }
+		public ScalingProblemInstanceProvider(int seed) : base()
+		{
+			Seed = seed;
+		}
+
+		public override IEnumerable<IDataDescriptor> GetDataDescriptors()
+		{
+			List<IDataDescriptor> descriptorList = new List<IDataDescriptor>();
+			var rand = new MersenneTwister((uint)Seed);
+			descriptorList.Add(new ScalingProblem1(rand.Next()));
+			descriptorList.Add(new ScalingProblem2(rand.Next()));
+			descriptorList.Add(new ScalingProblem3(rand.Next()));
+			descriptorList.Add(new ScalingProblem4(rand.Next()));
+			descriptorList.Add(new ScalingProblem5(rand.Next()));
+			return descriptorList;
+		}
+	}
+}