Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 17400)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 17401)
@@ -123,5 +123,5 @@
       var vectorDiv = new VectorDivision();
       var vectorSum = new VectorSum();
-      var vectorAvg = new VectorAverage();
+      var vectorAvg = new VectorMean();
       #endregion
 
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 17400)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 17401)
@@ -219,5 +219,5 @@
     <Compile Include="SymbolicDataAnalysisProblem.cs" />
     <Compile Include="SymbolicDataAnalysisSolutionImpactValuesCalculator.cs" />
-    <Compile Include="Symbols\VectorAverage.cs" />
+    <Compile Include="Symbols\VectorMean.cs" />
     <Compile Include="Symbols\VectorSum.cs" />
     <Compile Include="Symbols\VectorSubtraction.cs" />
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs	(revision 17400)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs	(revision 17401)
@@ -147,5 +147,5 @@
     public const byte VectorDiv = (byte)OpCode.VectorDiv;
     public const byte VectorSum = (byte)OpCode.VectorSum;
-    public const byte VectorAvg = (byte)OpCode.VectorAvg;
+    public const byte VectorMean = (byte)OpCode.VectorAvg;
 
 
@@ -210,5 +210,5 @@
       { typeof(VectorDivision), OpCodes.VectorDiv },
       { typeof(VectorSum), OpCodes.VectorSum },
-      { typeof(VectorAverage), OpCodes.VectorAvg }
+      { typeof(VectorMean), OpCodes.VectorMean }
     };
 
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 17400)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 17401)
@@ -536,5 +536,5 @@
             return v.Sum();
           }
-        case OpCodes.VectorAvg: {
+        case OpCodes.VectorMean: {
             DoubleVector v = VectorEvaluate(dataset, ref row, state);
             return v.Mean();
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/VectorAverage.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/VectorAverage.cs	(revision 17400)
+++ 	(revision )
@@ -1,48 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HEAL.Attic;
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
-  [StorableType("85FF9A2E-207C-4008-BB8B-0C0363885443")]
-  [Item("VectorAverage", "Symbol that represents the average function.")]
-  public sealed class VectorAverage : Symbol {
-    private const int minimumArity = 1;
-    private const int maximumArity = 1;
-
-    public override int MinimumArity {
-      get { return minimumArity; }
-    }
-    public override int MaximumArity {
-      get { return maximumArity; }
-    }
-
-    [StorableConstructor]
-    private VectorAverage(StorableConstructorFlag _) : base(_) { }
-    private VectorAverage(VectorAverage original, Cloner cloner) : base(original, cloner) { }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new VectorAverage(this, cloner);
-    }
-    public VectorAverage() : base("VectorAverage", "Symbol that represents the average function.") { }
-  }
-}
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/VectorMean.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/VectorMean.cs	(revision 17401)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/VectorMean.cs	(revision 17401)
@@ -0,0 +1,48 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HEAL.Attic;
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableType("85FF9A2E-207C-4008-BB8B-0C0363885443")]
+  [Item("VectorMean", "Symbol that represents the mean function.")]
+  public sealed class VectorMean : Symbol {
+    private const int minimumArity = 1;
+    private const int maximumArity = 1;
+
+    public override int MinimumArity {
+      get { return minimumArity; }
+    }
+    public override int MaximumArity {
+      get { return maximumArity; }
+    }
+
+    [StorableConstructor]
+    private VectorMean(StorableConstructorFlag _) : base(_) { }
+    private VectorMean(VectorMean original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VectorMean(this, cloner);
+    }
+    public VectorMean() : base("VectorMean", "Symbol that represents the mean function.") { }
+  }
+}
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesDataDescriptor.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesDataDescriptor.cs	(revision 17401)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesDataDescriptor.cs	(revision 17401)
@@ -0,0 +1,36 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class TimeSeriesDataDescriptor : IDataDescriptor {
+    public string Name { get; }
+    public string Description { get { return string.Empty; } }
+
+    internal string TrainingEntryName { get; }
+    internal string TestEntryName { get; }
+
+    public TimeSeriesDataDescriptor(string name, string trainingEntryName, string testEntryName) {
+      Name = name;
+      TrainingEntryName = trainingEntryName;
+      TestEntryName = testEntryName;
+    }
+  }
+}
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesInstanceProvider.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesInstanceProvider.cs	(revision 17401)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesInstanceProvider.cs	(revision 17401)
@@ -0,0 +1,181 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Collections.ObjectModel;
+using System.Diagnostics;
+using System.Globalization;
+using System.IO;
+using System.IO.Compression;
+using System.Linq;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public abstract class TimeSeriesInstanceProvider : ResourceClassificationInstanceProvider {
+    //public override string Name {
+    //  get { return "TimeSeries (Univariate) Problems"; }
+    //}
+    public override string Description {
+      get { return "UEA & UCR TimeSeries Problems"; }
+    }
+    public override Uri WebLink {
+      get { return new Uri("http://www.timeseriesclassification.com/"); }
+    }
+    public override string ReferencePublication {
+      get { return "Anthony Bagnall, Jason Lines, William Vickers and Eamonn Keogh, The UEA & UCR Time Series Classification Repository, www.timeseriesclassification.com"; }
+    }
+
+    public override IClassificationProblemData LoadData(IDataDescriptor id) {
+      var descriptor = (TimeSeriesDataDescriptor)id;
+      using (var instancesZipFile = OpenZipArchive()) {
+        var trainingEntry = instancesZipFile.GetEntry(descriptor.TrainingEntryName);
+        var testEntry = instancesZipFile.GetEntry(descriptor.TestEntryName);
+
+        if (trainingEntry == null || testEntry == null) {
+          throw new InvalidOperationException("The training or test entry could not be found in the archive.");
+        }
+
+        using (var trainingReader = new StreamReader(trainingEntry.Open()))
+        using (var testReader = new StreamReader(testEntry.Open())) {
+          ParseMetadata(trainingReader, out var inputVariables, out string targetVariable);
+          ParseMetadata(testReader, out _, out _); // ignore outputs
+
+          // Read data
+          var inputsData = new List<DoubleVector>[inputVariables.Count];
+          for (int i = 0; i < inputsData.Length; i++) inputsData[i] = new List<DoubleVector>();
+          var targetData = new List<double>();
+          ReadData(trainingReader, inputsData, targetData, out int numTrainingRows);
+          ReadData(testReader, inputsData, targetData, out int numTestRows);
+
+          // Build dataset
+          var dataset = new Dataset(
+            inputVariables.Concat(new[] { targetVariable }),
+            inputsData.Cast<IList>().Concat(new[] { targetData })
+          );
+          Debug.Assert(dataset.Rows == numTrainingRows + numTestRows);
+          Debug.Assert(dataset.Columns == inputVariables.Count + 1);
+
+          // Build problem data
+          var problemData = new ClassificationProblemData(dataset, inputVariables, targetVariable) {
+            Name = descriptor.Name
+          };
+          problemData.TrainingPartition.Start = 0;
+          problemData.TrainingPartition.End = numTrainingRows;
+          problemData.TestPartition.Start = numTrainingRows;
+          problemData.TestPartition.End = numTrainingRows + numTestRows;
+
+          return problemData;
+        }
+      }
+    }
+
+    private static void ParseMetadata(StreamReader reader, out List<string> inputVariables, out string targetVariable) {
+      int nrOfInputs = 0;
+      bool dataStart = false;
+      while (!reader.EndOfStream && !dataStart) {
+        var line = reader.ReadLine();
+        if (line.StartsWith("#")) {
+          // Comment
+        } else if (line.StartsWith("@")) {
+          var splits = line.Split(' ');
+          var type = splits.First();
+          var arguments = splits.Skip(1).ToList();
+          switch (type.ToLowerInvariant()) {
+            case "@univariate":
+              bool univariate = bool.Parse(arguments[0]);
+              if (univariate)
+                nrOfInputs = 1;
+              break;
+            case "@dimensions":
+              int dimensions = int.Parse(arguments[0]);
+              nrOfInputs = dimensions;
+              break;
+            case "@data":
+              dataStart = true;
+              break;
+          }
+        } else {
+          throw new InvalidOperationException("A data section already occurred within metadata section.");
+        }
+      }
+
+      int digits = Math.Max((int)Math.Log10(nrOfInputs - 1) + 1, 1);
+      inputVariables = Enumerable.Range(0, nrOfInputs)
+        .Select(i => "X" + i.ToString("D" + digits))
+        .ToList();
+
+      targetVariable = "Y";
+    }
+
+    private static void ReadData(StreamReader reader, List<DoubleVector>[] inputsData, List<double> targetData, out int count) {
+      count = 0;
+      while (!reader.EndOfStream) {
+        var line = reader.ReadLine();
+        var variables = line.Split(':');
+
+        // parse all except last, which is the non-vector target
+        for (int i = 0; i < variables.Length - 1; i++) {
+          var variable = variables[i];
+          var numbers = variable
+            .Split(',')
+            .Select(d => double.Parse(d, CultureInfo.InvariantCulture))
+            .ToList();
+          inputsData[i].Add(new DoubleVector(numbers));
+        }
+
+        var target = double.Parse(variables[variables.Length - 1], CultureInfo.InvariantCulture);
+        targetData.Add(target);
+
+        count++;
+      }
+    }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      using (var instancesZipFile = OpenZipArchive()) {
+        var instances = GroupEntriesByInstance(instancesZipFile.Entries);
+        var descriptors = instances.Select(instance => CreateDescriptor(instance.Key, instance.Value));
+
+        return descriptors.ToList();
+      }
+    }
+
+    private ZipArchive OpenZipArchive() {
+      var instanceArchiveName = GetResourceName(FileName + @"\.zip");
+      return new ZipArchive(GetType().Assembly.GetManifestResourceStream(instanceArchiveName), ZipArchiveMode.Read);
+    }
+
+    private static IDictionary<string, List<ZipArchiveEntry>> GroupEntriesByInstance(ReadOnlyCollection<ZipArchiveEntry> entries) {
+      var topLevelEntries = entries.Where(entry => string.IsNullOrEmpty(entry.Name)).ToList();
+
+      return topLevelEntries.ToDictionary(
+        entry => Path.GetDirectoryName(entry.FullName),
+        entry => entries.Except(topLevelEntries).Where(subEntry => subEntry.FullName.StartsWith(entry.FullName)).ToList());
+    }
+
+    private static TimeSeriesDataDescriptor CreateDescriptor(string name, List<ZipArchiveEntry> subEntries) {
+      var trainingEntry = subEntries.Single(entry => entry.Name.EndsWith("_TRAIN.ts"));
+      var testEntry = subEntries.Single(entry => entry.Name.EndsWith("_TEST.ts"));
+      return new TimeSeriesDataDescriptor(name, trainingEntry.FullName, testEntry.FullName);
+    }
+  }
+}
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesMultivariateInstanceProvider.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesMultivariateInstanceProvider.cs	(revision 17401)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesMultivariateInstanceProvider.cs	(revision 17401)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class TimeSeriesMultivariateInstanceProvider : TimeSeriesInstanceProvider {
+    public override string Name {
+      get { return "TimeSeries (Multivariate)"; }
+    }
+
+    protected override string FileName { get { return "TimeSeriesMultivariate"; } }
+  }
+}
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesUnivariateInstanceProvider.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesUnivariateInstanceProvider.cs	(revision 17401)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/TimeSeries/TimeSeriesUnivariateInstanceProvider.cs	(revision 17401)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class TimeSeriesUnivariateInstanceProvider : TimeSeriesInstanceProvider {
+    public override string Name {
+      get { return "TimeSeries (Univariate)"; }
+    }
+
+    protected override string FileName { get { return "TimeSeriesUnivariate"; } }
+  }
+}
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17400)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17401)
@@ -24,5 +24,5 @@
     <WarningLevel>4</WarningLevel>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>6</LangVersion>
+    <LangVersion>7.0</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -34,5 +34,5 @@
     <WarningLevel>4</WarningLevel>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>6</LangVersion>
+    <LangVersion>7.0</LangVersion>
   </PropertyGroup>
   <PropertyGroup>
@@ -134,4 +134,8 @@
     <Compile Include="Classification\ResourceClassificationDataDescriptor.cs" />
     <Compile Include="Classification\ResourceClassificationInstanceProvider.cs" />
+    <Compile Include="Classification\TimeSeries\TimeSeriesMultivariateInstanceProvider.cs" />
+    <Compile Include="Classification\TimeSeries\TimeSeriesUnivariateInstanceProvider.cs" />
+    <Compile Include="Classification\TimeSeries\TimeSeriesInstanceProvider.cs" />
+    <Compile Include="Classification\TimeSeries\TimeSeriesDataDescriptor.cs" />
     <Compile Include="Classification\UCI\WisconsinDiagnosticBreastCancer.cs" />
     <Compile Include="Classification\UCI\Vertebral_3C.cs" />
@@ -243,4 +247,9 @@
     <Compile Include="Regression\Various\SpatialCoevolution.cs" />
     <Compile Include="Regression\Various\VariousInstanceProvider.cs" />
+    <Compile Include="Regression\VectorData\AzzaliKorns5.cs" />
+    <Compile Include="Regression\VectorData\AzzaliBenchmark3.cs" />
+    <Compile Include="Regression\VectorData\AzzaliBenchmark2.cs" />
+    <Compile Include="Regression\VectorData\AzzaliBenchmark1.cs" />
+    <Compile Include="Regression\VectorData\RandomExtensions.cs" />
     <Compile Include="Regression\VectorData\VariousInstanceProvider.cs" />
     <Compile Include="Regression\VectorData\VectorDataTestOne.cs" />
@@ -261,4 +270,6 @@
   <ItemGroup>
     <EmbeddedResource Include="Classification\Data\UCI.zip" />
+    <EmbeddedResource Include="Classification\Data\TimeSeriesMultivariate.zip" />
+    <EmbeddedResource Include="Classification\Data\TimeSeriesUnivariate.zip" />
     <None Include="HeuristicLab.snk" />
     <None Include="Plugin.cs.frame" />